/* indent:4  tabsize:8  font:fixed-width */

/*---------------------------------------------------------------------------
|----------------------------------------------------------------------------
|
|    Seeheaven:GameModule
|
|    Seeheaven Solitaire module.
|
|    CREDITS
|
|    Gary Ritchie<gary@uaneuro.uah.ualberta.ca>
|        -- design, implementation, documentation
|
|----------------------------------------------------------------------------
\---------------------------------------------------------------------------*/


#import <appkit/appkit.h>
#import "../Solitaire/GameModule.h"

@interface Seeheaven:GameModule
{
    id gamePileView1;
    id gamePileView2;
    id gamePileView3;
    id gamePileView4;
    id gamePileView5;
    id gamePileView6;
    id gamePileView7;
    id gamePileView8;
    id gamePileView9;
    id gamePileView10;

    id tempPileView1;
    id tempPileView2;
    id tempPileView3;
    id tempPileView4;
    
    id suitPileView1;
    id suitPileView2;
    id suitPileView3;
    id suitPileView4;

    id suitPileDelegate;
    id tempPileDelegate;
    id gamePileDelegate;

    id drawCardPile;
    id prevDeck;

    id  suitCardPiles[4];
    id  gameCardPiles[10];
    id  tempCardPiles[4];

    id  undoList;
}


- setupGame:(BOOL)redeal;

- (BOOL) checkMovable: aCardPileView;
- checkForWin;

- logAddCard: aCard in: aCardPileView ;
- logRemoveCard: aCard in: aCardPileView ;
- logFlipCard: aCard in: aCardPileView ;
- logCheck;

- redo: sender;
- undo: sender;

@end
