/* indent:4  tabsize:8  font:fixed-width */


#import "SeeheavenTempDelegate.h"
#import "SeeheavenSuitDelegate.h"
#import "../Solitaire/Solitaire.h"
#import "../Solitaire/CardSet.subproj/cardset.h"
#import "Seeheaven.h"
#import "SeeheavenUndoList.h"


@implementation SeeheavenTempDelegate

- setSuitCardPileViews:(id [])theViews
{
    int i;
    
    for (i=0; i<4; i++)
        suitCardPileViews[i] = *(theViews + i);

    return self;
}
    

- doubleClickedCard:aCard in:aCardPileView
{
    int i;
    
    id cardPile = [aCardPileView cardPile];
    
    if ((aCard == [cardPile cardAt:CS_TOP]) && (![aCard isFaceUp]))
    {
        [aCard flip];
	[SolGameController() logFlipCard: aCard in: aCardPileView];
        [aCardPileView display];
	[SolGameController() checkForWin];
	[SolGameController() logCheck];
    }
    else if (aCard == [cardPile cardAt:CS_TOP])
    {
        for (i = 0; i < 4; i++)
        {
            [[suitCardPileViews[i] delegate] setDoubleClickCheck];
            if ([[suitCardPileViews[i] delegate] canAcceptPile:cardPile
	                                       from:aCardPileView
	                                         in:suitCardPileViews[i]])
            {
                [[suitCardPileViews[i] cardPile] 
		                   addCard:[cardPile cardAt:CS_TOP]];
		[SolGameController() 
		    logAddCard: aCard in: suitCardPileViews[i]];
                [cardPile removeCard:[cardPile cardAt:CS_TOP]];
		[SolGameController() logRemoveCard: aCard in: aCardPileView];
                [aCardPileView display];
                [suitCardPileViews[i] display];

		[SolGameController() checkForWin];
		[SolGameController() logCheck];
                return self;
            }
        }
    }
    return self;
}


- (BOOL)canAcceptPile:aCardPile from:sender in:aCardPileView
{
    if ([[aCardPileView cardPile] cardCount] == 0
	&& [aCardPile cardCount] == 1)
	{
	    return YES;
	}
    return NO;
}


- (BOOL)draggedPile:aCardPile from:aCardPileView
{
    return YES;
}


- removedPile:aCardPile from:aCardPileView
{
    [SolGameController() logRemoveCard: [aCardPile cardAt: CS_TOP]
        in: aCardPileView];
    [SolGameController() checkForWin];
    [SolGameController() logCheck];
    return self;
}

- acceptPile:aCardPile in:aCardPileView
{
    [SolGameController() logAddCard: [aCardPile cardAt: CS_TOP]
        in: aCardPileView];
    return self;
}


@end
