/* indent:4  tabsize:8  font:fixed-width */

/*---------------------------------------------------------------------------
|----------------------------------------------------------------------------
|
|    Seeheaven:Undo list
|
|    Seeheaven Undo module.
|
|    CREDITS
|
|    Shinji Kono <kono@ie.u-ryukyu.ac.jp>
|        -- design, implementation, documentation
|
|----------------------------------------------------------------------------
\---------------------------------------------------------------------------*/

#import <objc/List.h>

#import <appkit/appkit.h>

typedef
    enum change_type { C_OK, C_ADD, C_REMOVE, C_FLIP, C_COMMIT}
change_type;

@interface SeeheavenChange:Object
{
    id changer;
    id card;
    change_type type;
}

- set: aCard in: aCardPileview as: (change_type) t;
- (change_type) doChange;
- (change_type) undoChange;
@end

@interface SeeheavenUndoList:List
{
    int current;     
    int last;       
    /* 
        During undo/redo
	    current <= last <= [self count]
	When a change is made by a user
	    current == last <= [self count]
	gameRestart: means
	    reset current = 0 ... all undo 
	newGame: or redeal: means
	    clear current = last = 0 
     */
}

- reset;
- clear;

- logAddCard: aCard in: aCardPileView ;
- logRemoveCard: aCard in: aCardPileView ;
- logFlipCard: aCard in: aCardPileView ;
- logCheck;

- undo;
- redo;

@end
